package cat.xaviermarin.pm.service.jpa;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import cat.xaviermarin.pm.domain.Assignation;
import cat.xaviermarin.pm.repository.AssignationRepository;
import cat.xaviermarin.pm.service.AssignationService;

import com.google.common.collect.Lists;

@Service("assignationService")
@Repository
@Transactional
public class AssignationServiceImpl implements AssignationService {

	final static Logger logger = LoggerFactory.getLogger(AssignationServiceImpl.class);
	
	@Autowired
	private AssignationRepository assignationRepository;
	
	@Transactional(readOnly=true)
	public List<Assignation> findAll() {
		logger.info("Finding all assignations");
		return Lists.newArrayList(assignationRepository.findAll());
	}

	@Transactional(readOnly=true)
	public Assignation findById(Long id) {
		return assignationRepository.findOne(id);
	}

	public Assignation save(Assignation assignation) {
		return assignationRepository.save(assignation);
	}
	
	public void delete(Long id){
		assignationRepository.delete(id);
	}
	
}
