package cat.xaviermarin.pm.service.jpa;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import cat.xaviermarin.pm.domain.Project;
import cat.xaviermarin.pm.repository.ProjectRepository;
import cat.xaviermarin.pm.service.ProjectService;

import com.google.common.collect.Lists;

@Service("projectService")
@Repository
@Transactional
public class ProjectServiceImpl implements ProjectService {

	final static Logger logger = LoggerFactory.getLogger(ProjectServiceImpl.class);
	
	@Autowired
	private ProjectRepository projectRepository;
	
	@Transactional(readOnly=true)
	public List<Project> findAll() {
		logger.info("Finding all projects");
		return Lists.newArrayList(projectRepository.findAll());
	}

	@Transactional(readOnly=true)
	public Project findById(Long id) {
		return projectRepository.findOne(id);
	}

	public Project save(Project project) {
		return projectRepository.save(project);
	}
	
	public void delete(Long id){
		projectRepository.delete(id);
	}
	
}
