package cat.xaviermarin.pm.service.jpa;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import cat.xaviermarin.pm.domain.Role;
import cat.xaviermarin.pm.repository.RoleRepository;
import cat.xaviermarin.pm.service.RoleService;

import com.google.common.collect.Lists;

@Service("roleService")
@Repository
@Transactional
public class RoleServiceImpl implements RoleService {

	final static Logger logger = LoggerFactory.getLogger(RoleServiceImpl.class);
	
	@Autowired
	private RoleRepository roleRepository;
	
	@Transactional(readOnly=true)
	public List<Role> findAll() {
		logger.info("RoleServiceImpl.findAll");
		return Lists.newArrayList(roleRepository.findAll());
	}

	@Transactional(readOnly=true)
	public Role findById(Long id) {
		logger.info("RoleServiceImpl.findById with id: {}", id);
		return roleRepository.findOne(id);
	}

	public Role save(Role role) {
		logger.info("RoleServiceImpl.save");
		return roleRepository.save(role);
	}
	
	public void delete(Long id){
		logger.info("RoleServiceImpl.delete");
		roleRepository.delete(id);
	}
	
}
