package cat.xaviermarin.pm.service.jpa;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import cat.xaviermarin.pm.domain.User;
import cat.xaviermarin.pm.repository.UserRepository;
import cat.xaviermarin.pm.service.UserService;

import com.google.common.collect.Lists;

@Service("userService")
@Repository
@Transactional
public class UserServiceImpl implements UserService {

	final static Logger logger = LoggerFactory.getLogger(UserServiceImpl.class);
	
	@Autowired
	private UserRepository userRepository;
	
	@Transactional(readOnly=true)
	public List<User> findAll() {
		logger.info("Finding all users");
		return Lists.newArrayList(userRepository.findAll());
	}

	@Transactional(readOnly=true)
	public User findById(Long id) {
		return userRepository.findOne(id);
	}

	public User save(User user) {
		return userRepository.save(user);
	}
	
	public void delete(Long id){
		userRepository.delete(id);
	}
	
}
