package cat.xaviermarin.pm.web.controller;

//import java.util.ArrayList;
//import java.util.HashSet;
//import java.util.List;
//import java.util.Set;

//import org.primefaces.model.DualListModel;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.binding.message.MessageBuilder;
import org.springframework.stereotype.Component;
import org.springframework.webflow.execution.RequestContext;

import cat.xaviermarin.pm.domain.Role;
//import cat.xaviermarin.pm.domain.Hobby;
import cat.xaviermarin.pm.service.RoleService;
//import cat.xaviermarin.pm.service.HobbyService;
import cat.xaviermarin.pm.web.view.RoleBean;
import cat.xaviermarin.pm.web.view.RoleListBean;

@Component("roleController")
public class RoleController extends BaseController {

	private static final Logger logger = LoggerFactory.getLogger(RoleController.class);

	@Autowired
	private RoleService roleService;
	
	//
	// BEANS MANAGEMENT
	//
	
	// RECOVERS ROLE LIST AND SET IT IN LISTBEAN
	public RoleListBean getRoleListBean() {		
		logger.info("Getting role list bean");
		RoleListBean roleListBean = new RoleListBean();		
		roleListBean.setRoles(roleService.findAll());		
		return roleListBean;		
	}
	
	// CREATES A NEW EMPTY ROLE BEAN
	public RoleBean newRoleBean() {		
		logger.info("newRoleBean");
		RoleBean roleBean = new RoleBean();	
		Role role = new Role();
		roleBean.setRole(role);	
		return roleBean;		
	}

	// CREATES A FULL ROLE BEAN
	public RoleBean getRoleBean(RequestContext context) {		
		logger.info("getRoleBean");
		RoleBean roleBean = new RoleBean();	
		Role role = new Role();		
		role = this.getRole(context);	
		roleBean.setRole(role);	
		return roleBean;		
	}
	
	//
	// VIEW ACTIONS
	//
	
	public void deleteRole(RequestContext context) {
		logger.info("deleteRole");
		Long id = context.getRequestScope().getLong("roleId");
		logger.info("Selected role id: {}", id);
		roleService.delete(id);
	}
	
	public Role showRole(RequestContext context) {		
		logger.info("showRole");		
		return this.getRole(context);
	}	
	
	public void saveRole(RequestContext context) {	
		logger.info("saveRole");		
		// Retrieve contact bean
		RoleBean roleBean = (RoleBean) context.getFlowScope().get("roleBean");
		Role role = roleBean.getRole();		
		roleService.save(role);				
		logger.info("Role {} {} saved successfully", role.getId(), role.getName());		
		context.getMessageContext().addMessage(new MessageBuilder().info().code("message_role_save_success").build());		
	}	

	//
	// PRIVATE
	//
	
	private Role getRole(RequestContext context) {
		logger.info("getRole");		
		Long id = context.getRequestScope().getLong("roleId");		
		logger.info("Selected role id: {}", id);		
		return roleService.findById(id);			
	}
}
