package cat.xaviermarin.pm.web.converter;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cat.xaviermarin.pm.domain.Assignation;
import cat.xaviermarin.pm.service.AssignationService;

@Component
public class AssignationConverter implements Converter {
	/*
	 * http://stackoverflow.com/questions/7096632/validation-error-value-is-not-valid
	 */
	private static final Logger logger = LoggerFactory.getLogger(AssignationConverter.class);

	@Autowired
	private AssignationService assignationService;
	
	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String value) {
		logger.debug("AssignationConverter.getAsObject with value {}", value);
		if(value != null && !value.equals("")){
			Assignation assignation = assignationService.findById(Long.valueOf(value));
			//logger.info("AssignationConverter.getAsObject obtained assignation: {} - {}", assignation.getId(), assignation.getName());
			return assignation;
		}
		return null;
	}

	@Override
	public String getAsString(FacesContext context, UIComponent comonent, Object value) {		
		logger.debug("AssignationConverter.getAsString with value {}", value);
		Assignation assignation = (Assignation) value;
		return assignation.getId()!=null?String.valueOf(assignation.getId()):null;
	}

}
