package cat.xaviermarin.pm.web.converter;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cat.xaviermarin.pm.domain.Milestone;
import cat.xaviermarin.pm.service.MilestoneService;

import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;

@FacesConverter("jodaDateTimeConverter")
public class JodaDateTimeConverter implements Converter {

	private static final Logger logger = LoggerFactory.getLogger(JodaDateTimeConverter.class);
	
	private static final String PATTERN = "yyyy-MM-dd";
	
	@Override
	public Object getAsObject(FacesContext ctx, UIComponent component, String value) {
		logger.debug("getAsObject with value:", value);
		return DateTimeFormat.forPattern(PATTERN).parseDateTime(value).toString().substring(0, 10);
		//return value;
	}

	@Override
	public String getAsString(FacesContext ctx, UIComponent component, Object value) {
		logger.debug("getAsString with value:", value);
		//DateFormat df=new SimpleDateFormat(PATTERN);
		//String s=df.format((String)value);
		
		//String inputPattern = "dd-MMM-yy hh.mm.ss aa";
	    //DateTime dateTime  = DateTime.parse((String)s.toString(), DateTimeFormat.forPattern(PATTERN));
		//DateTime dateTime = (DateTime) s.toString();		
		//return DateTimeFormat.forPattern(PATTERN).print(dateTime);
		return (String) value;
		

	}	
}
