package cat.xaviermarin.pm.web.converter;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cat.xaviermarin.pm.domain.Milestone;
import cat.xaviermarin.pm.service.MilestoneService;

@Component
public class MilestoneConverter implements Converter {
	/*
	 * http://stackoverflow.com/questions/7096632/validation-error-value-is-not-valid
	 */
	private static final Logger logger = LoggerFactory.getLogger(MilestoneConverter.class);

	@Autowired
	private MilestoneService milestoneService;
	
	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String value) {
		logger.debug("MilestoneConverter.getAsObject with value {}", value);
		if(value != null && !value.equals("")){
			Milestone milestone = milestoneService.findById(Long.valueOf(value));
			//logger.info("MilestoneConverter.getAsObject obtained milestone: {} - {}", milestone.getId(), milestone.getName());
			return milestone;
		}
		return null;
	}

	@Override
	public String getAsString(FacesContext context, UIComponent comonent, Object value) {		
		logger.debug("MilestoneConverter.getAsString with value {}", value);
		Milestone milestone = (Milestone) value;
		return milestone.getId()!=null?String.valueOf(milestone.getId()):null;
	}

}
