package cat.xaviermarin.pm.web.converter;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cat.xaviermarin.pm.domain.Role;
import cat.xaviermarin.pm.service.RoleService;

@Component
public class RoleConverter implements Converter {
	/*
	 * http://stackoverflow.com/questions/7096632/validation-error-value-is-not-valid
	 */
	private static final Logger logger = LoggerFactory.getLogger(RoleConverter.class);

	@Autowired
	private RoleService roleService;
	
	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String value) {
		logger.debug("RoleConverter.getAsObject with value {}", value);
		if(value != null && !value.equals("")){
			Role role = roleService.findById(Long.valueOf(value));
			//logger.info("RoleConverter.getAsObject obtained role: {} - {}", role.getId(), role.getName());
			return role;
		}
		return null;
	}

	@Override
	public String getAsString(FacesContext context, UIComponent comonent, Object value) {		
		logger.debug("RoleConverter.getAsString with value {}", value);
		Role role = (Role) value;
		return role.getId()!=null?String.valueOf(role.getId()):null;
	}

}
