package cat.xaviermarin.pm.web.converter;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cat.xaviermarin.pm.domain.Task;
import cat.xaviermarin.pm.service.TaskService;

@Component
public class TaskConverter implements Converter {
	/*
	 * http://stackoverflow.com/questions/7096632/validation-error-value-is-not-valid
	 */
	private static final Logger logger = LoggerFactory.getLogger(TaskConverter.class);

	@Autowired
	private TaskService taskService;
	
	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String value) {
		logger.debug("TaskConverter.getAsObject with value {}", value);
		if(value != null && !value.equals("")){
			Task task = taskService.findById(Long.valueOf(value));
			//logger.info("TaskConverter.getAsObject obtained task: {} - {}", task.getId(), task.getName());
			return task;
		}
		return null;
	}

	@Override
	public String getAsString(FacesContext context, UIComponent comonent, Object value) {		
		logger.debug("TaskConverter.getAsString with value {}", value);
		Task task = (Task) value;
		return task.getId()!=null?String.valueOf(task.getId()):null;
	}

}
