package cat.xaviermarin.pm.web.converter;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cat.xaviermarin.pm.domain.User;
import cat.xaviermarin.pm.service.UserService;

@Component
public class UserConverter implements Converter {
	/*
	 * http://stackoverflow.com/questions/7096632/validation-error-value-is-not-valid
	 */
	private static final Logger logger = LoggerFactory.getLogger(UserConverter.class);

	@Autowired
	private UserService userService;
	
	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String value) {
		logger.debug("UserConverter.getAsObject with value {}", value);
		if(value != null && !value.equals("")){
			User user = userService.findById(Long.valueOf(value));
			//logger.info("UserConverter.getAsObject obtained user: {} - {}", user.getId(), user.getName());
			return user;
		}
		return null;
	}

	@Override
	public String getAsString(FacesContext context, UIComponent comonent, Object value) {		
		logger.debug("UserConverter.getAsString with value {}", value);
		User user = (User) value;
		return user.getId()!=null?String.valueOf(user.getId()):null;
	}

}
