package cat.xaviermarin.pm.web.view;
import java.io.Serializable;
import java.util.Locale;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@ManagedBean
@SessionScoped
public class LocaleBean implements Serializable {

	private static final long serialVersionUID = 1L;
	
	private Locale locale = FacesContext.getCurrentInstance().getViewRoot().getLocale();
    private static final Logger logger = LoggerFactory.getLogger(LocaleBean.class);
    
    public Locale getLocale() {
    	logger.debug("getLocale, Language: {} - locale.getDisplayName(): {}",locale.getLanguage(), locale.getDisplayName());
        return locale;
    }

    public String getLanguage() {
    	logger.debug("getLanguage, Language: {} - locale.getDisplayName(): {}",locale.getLanguage(), locale.getDisplayName());
        return locale.getLanguage();
    }

    public void setLanguage(String language) {
    	logger.debug("setLanguage: {}", language);
        locale = new Locale(language);        
        FacesContext.getCurrentInstance().getViewRoot().setLocale(locale);
    }

}